# Changelog

## [8.0.0](https://gitlab.developers.cam.ac.uk/uis/devops/infra/terraform/gke-cluster/compare/7.4.0...8.0.0) (2024-12-09)

### ⚠ BREAKING CHANGES

* add `enable_secret_manager` variable, remove `enable_secret_manager_auto_rotation` variable

### Features

* add `enable_secret_manager` variable, remove `enable_secret_manager_auto_rotation` variable ([ebe05af](https://gitlab.developers.cam.ac.uk/uis/devops/infra/terraform/gke-cluster/commit/ebe05af94abb11ae7acb3f00e7787454f48cfde3))

## [7.4.0](https://gitlab.developers.cam.ac.uk/uis/devops/infra/terraform/gke-cluster/compare/7.3.1...7.4.0) (2024-11-14)

### Features

* add optional parameter autoscaling_profile to cluster_autoscaling block ([cc030fa](https://gitlab.developers.cam.ac.uk/uis/devops/infra/terraform/gke-cluster/commit/cc030fa53e271def55216249117e1b8021c1e570))

## [7.3.1](https://gitlab.developers.cam.ac.uk/uis/devops/infra/terraform/gke-cluster/compare/7.3.0...7.3.1) (2024-10-24)

### Bug Fixes

* switch to use CHANGELOG.md as it was causing release-it issues ([6c182e4](https://gitlab.developers.cam.ac.uk/uis/devops/infra/terraform/gke-cluster/commit/6c182e4cb0e1b2dfc4d4b30006744e3b33608299))

## [7.3.0](https://gitlab.developers.cam.ac.uk/uis/devops/infra/terraform/gke-cluster/compare/7.2.0...7.3.0) (2024-10-24)

### Features

* allow deletion_protection to be overriden as 5.0+ provider now defaults this to true ([a5db07a](https://gitlab.developers.cam.ac.uk/uis/devops/infra/terraform/gke-cluster/commit/a5db07aad2df4301ca2d717b3e2e22518cc54860))

## [7.2.0] - 2024-07-02

### Fixed

- `network_policy_config` config block in `addons_config` must not exist in the autopilot mode.

## [7.1.0] - 2024-06-19

### Added

- `maintenance_policy` block is now configurable for the GKE cluster. Maintenance start time, end time,
  and recurrence can be customized.

## [7.0.0] - 2024-02-09

### Added

- **Breaking:** `networking_mode` variable added. By default it is set to `VPC_NATIVE` as new clusters should be created
  with that `networking_mode` by default. For exisiting clusters, created earlier than GKE version 1.21.0-gke.1500
  or created as a routes-based cluster intentionally, please set `networking_mode` to `ROUTES` explicitly
  to preserve old behavior.
- `resource_labels` optional variable added. Represents a map of key/value pairs of the GCE resource
  labels to be applied to the cluster.
- `enable_network_policy` optional variable added. If true, NetworkPolicy feature for GKE cluster
  will be enabled. Disabled by default.

## [6.0.0] - 2023-11-22

### Added

- **Breaking:** Cluster nodes in the autopilot mode now use provided `service_account`
in `cluster_autoscaling` configuration block. That means new clusters will work fine, but
existing clusters can't be upgraded with new service account.

## [5.2.4] - 2023-11-01

### Added

* Added support to publish to GitLab Terraform registry when tagged using semver

## [5.2.3] - 2023-10-05

### Fixed

- Fixed evaluation order dependency issue.

## [5.2.2] - 2023-10-04

### Added

- `cluster_notification_enabled` variable to control whether cluster notifications
are generated by the GKE cluster. Previously, we relied on `cluster_notifications_topic_id`
to enable this, but this can lead to evaluation order dependency issues.

## [5.2.1] - 2023-10-04

### Fixed

- `gateway_api_config.channel` was being set to null for Autopilot clusters, whereas
GCP now defaults this to `CHANNEL_STANDARD`. Now defaults to `CHANNEL_STANDARD` for
Autopilot clusters.

## [5.2.0] - 2023-09-12

### Fixed

- `autopilot_cloud_dns_enabled` variable to allow Autopilot clusters which haven't been
migrated from `kube-dns` to `CLOUD_DNS` to specify this fact. This is required as errors
will occur otherwise.

## [5.1.0] - 2023-08-31

### Added

- `cluster_notifications_topic_id` variable to allow cluster notifications to be enabled and
published to the supplied topic.

## [5.0.1] - 2023-08-18

### Fixed

- due to change in GCP behaviour, Autopilot now uses `CLOUD_DNS` rather than `kube-dns`, so need to ensure dns_config
settings for the cluster are set otherwise cluster replacement will be triggered unnecessarily.

## [5.0.0] - 2023-04-28

### Added

- `google.monitoring` provider added, which allows the cluster alerts to be created in a different project.
This provider must be supplied by the modules client - it can be the default or a different provider.

```terraform
  providers = {
    google.monitoring = <provider>
  }
```

## [4.1.0] - 2023-02-23

### Added

- `min_master_version` variable to allow targeting a specific cluster version when deploying.

## [4.0.3] - 2023-02-21

### Added

- New metric and alerting when `GKE auto-updates a cluster or nodepool`.

## [4.0.2] - 2023-02-09

### Fixed

 - Workaround implemented to allow Autopilot clusters to deploy when using `google` provider `>4.3.0` - see [this issue.](https://github.com/hashicorp/terraform-provider-google/issues/10782)
 - Tweaked no scale down alert to allow deploying multiple clusters to the same project.

## [4.0.1] - 2022-12-01
### Added
 - New metric and alerting when `no scale down of a node` event detected.

## [4.0.0] - 2022-11-25

### Added

- Ability to use custom service accounts for GKE nodes.

### Changed

- Removed `hashicorp\template` provider usage and replaced with built-in `templatefile` function.

### Fixed

- Deprecated `identity_namespace` option in `workload_identity_config` block replaced with `workload_pool`.
- Deprecated `node_metadata` option in `workload_metadata_config` block replaced with `mode`.

## [3.1.1] - 2022-08-16
### Changed
 - Removed token based auth and replaced with role based auth for kubeconfig.

## [3.1.0] - 2022-08-14
### Added
 - Remove support for client key and certificate credentials for kubconfig.
 Token based auth support only.

## [3.0.0] - 2022-02-03
### Changed
 - Added support for GKE Autopilot.

## [2.0.4] - 2022-02-03
### Changed
 - Added Client Token to generated kubeconfig.

## [2.0.3] - 2021-10-20
### Fixed
 - Fix over constrictive provider and terraform version specifiers to follow
   best practice.

## [2.0.2] - 2021-06-17
### Fixed
 - Fix invalid ip_allocation_policy block if no allocation policy is specified.

## [2.0.1] - 2021-06-17
### Changed
 - Add kubeconfig based authentication using client key and certificate

## [2.0.0] - 2021-05-18
### Changed
 - Backward incompatible release which has defaults which improve security
   hardening.

## [1.0.0] - 2021-05-18
### Added
 - Initial version with changelog
